<?php

namespace common\logic\Document\DeliveryNote;

use common\logic\ContainerInterface;

class DeliveryNoteContainer implements ContainerInterface
{
    public function getEntityFqcn(): string
    {
        return DeliveryNote::class;
    }

    public function getServices(): array
    {
        return [
            DeliveryNoteBuilder::class,
            DeliveryNoteSolver::class,
        ];
    }

    public function getFactory(): DeliveryNoteBuilder
    {
        return new DeliveryNoteBuilder();
    }

    public function getSolver(): DeliveryNoteSolver
    {
        return new DeliveryNoteSolver();
    }
}