<?php

namespace common\logic\Document\Invoice;

use common\logic\ContainerInterface;
use common\logic\Document\Document\DocumentBuilder;
use common\logic\Document\Document\DocumentSolver;
use common\logic\Document\Quotation\QuotationBuilder;
use common\logic\Document\Quotation\QuotationFactory;
use common\logic\Document\Quotation\Quotation;
use common\logic\PointSale\PointSale\QuotationRepository;

class QuotationContainer implements ContainerInterface
{
    public function getEntityFqcn(): string
    {
        return Quotation::class;
    }

    public function getServices(): array
    {
        return [
            QuotationBuilder::class,
        ];
    }

    public function getSolver(): DocumentSolver
    {
        return new DocumentSolver();
    }
    
    public function getRepository(): QuotationRepository
    {
        return new QuotationRepository();
    }

    public function getBuilder(): QuotationBuilder
    {
        return new QuotationBuilder();
    }
}