<?php

namespace common\logic\Order\ProductOrder;

use common\logic\ContainerInterface;
use common\logic\PointSale\PointSale\ProductOrderRepository;

class ProductOrderContainer implements ContainerInterface
{
    public function getEntityFqcn(): string
    {
        return ProductOrder::class;
    }

    public function getServices(): array
    {
        return [
            ProductOrderSolver::class,
            ProductOrderRepository::class,
            ProductOrderBuilder::class,
        ];
    }

    public function getSolver(): ProductOrderSolver
    {
        return new ProductOrderSolver();
    }

    public function getRepository(): ProductOrderRepository
    {
        return new ProductOrderRepository();
    }

    public function getBuilder(): ProductOrderBuilder
    {
        return new ProductOrderBuilder();
    }
}