<?php

namespace common\logic\Product\ProductCategory;

use common\helpers\GlobalParam;
use common\logic\BaseService;
use common\logic\RepositoryInterface;

class ProductCategoryRepository extends BaseService implements RepositoryInterface
{
    public function defaultOptionsSearch(): array
    {
        return [
            'with' => [],
            'join_with' => [],
            'orderby' => '',
            'attribute_id_producer' => ''
        ];
    }

    public function get()
    {
        return ProductCategory::searchAll([], ['orderby' => 'product_category.position ASC']);
    }

    public function populateDropdownList()
    {
        $productCategoriesArrayDropdown = ['' => '--'];
        $productCategoriesArray = $this->get();

        foreach ($productCategoriesArray as $productCategory) {
            $productCategoriesArrayDropdown[$productCategory['id']] = $productCategory['name'];
        }

        return $productCategoriesArrayDropdown;
    }
}